IRremoteESP8266: IRDaikinESP Class Reference

IRremoteESP8266

Public Member Functions | Static Public Member Functions | Private Member Functions | Private Attributes | List of all members
IRDaikinESP Class Reference

Class for handling detailed Daikin 280-bit A/C messages. More...

`#include <ir_Daikin.h>`

Collaboration diagram for IRDaikinESP:
[legend]

## Public Member Functions

| IRDaikinESP (const uint16_t pin, const bool inverted=false, const bool use_modulation=true)
| Class constructor. More...
void | send (const uint16_t repeat=kDaikinDefaultRepeat)
| Send the current internal state as an IR message. More...
int8_t | calibrate (void)
| Run the calibration to calculate uSec timing offsets for this platform. More...
void | begin (void)
| Set up hardware to be able to send a message. More...
void | on (void)
| Change the power setting to On. More...
void | off (void)
| Change the power setting to Off. More...
void | setPower (const bool on)
| Change the power setting. More...
bool | getPower (void) const
| Get the value of the current power setting. More...
void | setTemp (const uint8_t temp)
| Set the temperature. More...
uint8_t | getTemp (void) const
| Get the current temperature setting. More...
void | setFan (const uint8_t fan)
| Set the speed of the fan. More...
uint8_t | getFan (void) const
| Get the current fan speed setting. More...
void | setMode (const uint8_t mode)
| Set the operating mode of the A/C. More...
uint8_t | getMode (void) const
| Get the operating mode setting of the A/C. More...
void | setSwingVertical (const bool on)
| Set the Vertical Swing mode of the A/C. More...
bool | getSwingVertical (void) const
| Get the Vertical Swing mode of the A/C. More...
void | setSwingHorizontal (const bool on)
| Set the Horizontal Swing mode of the A/C. More...
bool | getSwingHorizontal (void) const
| Get the Horizontal Swing mode of the A/C. More...
bool | getQuiet (void) const
| Get the Quiet mode status of the A/C. More...
void | setQuiet (const bool on)
| Set the Quiet mode of the A/C. More...
bool | getPowerful (void) const
| Get the Powerful (Turbo) mode of the A/C. More...
void | setPowerful (const bool on)
| Set the Powerful (Turbo) mode of the A/C. More...
void | setSensor (const bool on)
| Set the Sensor mode of the A/C. More...
bool | getSensor (void) const
| Get the Sensor mode of the A/C. More...
void | setEcono (const bool on)
| Set the Economy mode of the A/C. More...
bool | getEcono (void) const
| Get the Economical mode of the A/C. More...
void | setMold (const bool on)
| Set the Mould mode of the A/C. More...
bool | getMold (void) const
| Get the Mould mode status of the A/C. More...
void | setComfort (const bool on)
| Set the Comfort mode of the A/C. More...
bool | getComfort (void) const
| Get the Comfort mode of the A/C. More...
void | enableOnTimer (const uint16_t starttime)
| Set the enable status & time of the On Timer. More...
void | disableOnTimer (void)
| Clear and disable the On timer. More...
uint16_t | getOnTime (void) const
| Get the On Timer time to be sent to the A/C unit. More...
bool | getOnTimerEnabled (void) const
| Get the enable status of the On Timer. More...
void | enableOffTimer (const uint16_t endtime)
| Set the enable status & time of the Off Timer. More...
void | disableOffTimer (void)
| Clear and disable the Off timer. More...
uint16_t | getOffTime (void) const
| Get the Off Timer time to be sent to the A/C unit. More...
bool | getOffTimerEnabled (void) const
| Get the enable status of the Off Timer. More...
void | setCurrentTime (const uint16_t mins_since_midnight)
| Set the clock on the A/C unit. More...
uint16_t | getCurrentTime (void) const
| Get the clock time to be sent to the A/C unit. More...
void | setCurrentDay (const uint8_t day_of_week)
| Set the current day of the week to be sent to the A/C unit. More...
uint8_t | getCurrentDay (void) const
| Get the current day of the week to be sent to the A/C unit. More...
void | setWeeklyTimerEnable (const bool on)
| Set the enable status of the Weekly Timer. More...
bool | getWeeklyTimerEnable (void) const
| Get the enable status of the Weekly Timer. More...
uint8_t * | getRaw (void)
| Get a PTR to the internal state/code for this protocol. More...
void | setRaw (const uint8_t new_code[], const uint16_t length=kDaikinStateLength)
| Set the internal state from a valid code for this protocol. More...
stdAc::state_t | toCommon (void) const
| Convert the current internal state into its stdAc::state_t equivalent. More...
String | toString (void) const
| Convert the current internal state into a human readable string. More...

## Static Public Member Functions

static bool | validChecksum (uint8_t state[], const uint16_t length=kDaikinStateLength)
| Verify the checksum is valid for a given state. More...
static uint8_t | convertMode (const stdAc::opmode_t mode)
| Convert a stdAc::opmode_t enum into its native mode. More...
static uint8_t | convertFan (const stdAc::fanspeed_t speed)
| Convert a stdAc::fanspeed_t enum into it's native speed. More...
static stdAc::opmode_t | toCommonMode (const uint8_t mode)
| Convert a native mode into its stdAc equivalent. More...
static stdAc::fanspeed_t | toCommonFanSpeed (const uint8_t speed)
| Convert a native fan speed into its stdAc equivalent. More...

## Private Member Functions

void | stateReset (void)
| Reset the internal state to a fixed known good state. More...
void | checksum (void)
| Calculate and set the checksum values for the internal state. More...

## Private Attributes

IRsend | _irsend
| instance of the IR send class More...
DaikinESPProtocol | _

## Detailed Description

Class for handling detailed Daikin 280-bit A/C messages.

## Constructor & Destructor Documentation

## ◆ IRDaikinESP()

IRDaikinESP::IRDaikinESP | ( | const uint16_t | pin,
|  | const bool | inverted = `false`,
|  | const bool | use_modulation = `true`
| ) |  |

explicit

Class constructor.

Parameters

  [in] | pin | GPIO to be used when sending.
  [in] | inverted | Is the output signal to be inverted?
  [in] | use_modulation | Is frequency modulation to be used?

## Member Function Documentation

## ◆ begin()

void IRDaikinESP::begin | ( | void |  | ) |

Set up hardware to be able to send a message.

## ◆ calibrate()

int8_t IRDaikinESP::calibrate | ( | void |  | ) |

inline

Run the calibration to calculate uSec timing offsets for this platform.

Returns
  The uSec timing offset needed per modulation of the IR Led.

Note
  This will produce a 65ms IR signal pulse at 38kHz. Only ever needs to be run once per object instantiation, if at all.

## ◆ checksum()

void IRDaikinESP::checksum | ( | void |  | ) |

private

Calculate and set the checksum values for the internal state.

## ◆ convertFan()

uint8_t IRDaikinESP::convertFan | ( | const stdAc::fanspeed_t | speed | ) |

static

Convert a stdAc::fanspeed_t enum into it's native speed.

Parameters

  [in] | speed | The enum to be converted.

Returns
  The native equivalent of the enum.

## ◆ convertMode()

uint8_t IRDaikinESP::convertMode | ( | const stdAc::opmode_t | mode | ) |

static

Convert a stdAc::opmode_t enum into its native mode.

Parameters

  [in] | mode | The enum to be converted.

Returns
  The native equivalent of the enum.

## ◆ disableOffTimer()

void IRDaikinESP::disableOffTimer | ( | void |  | ) |

Clear and disable the Off timer.

## ◆ disableOnTimer()

void IRDaikinESP::disableOnTimer | ( | void |  | ) |

Clear and disable the On timer.

## ◆ enableOffTimer()

void IRDaikinESP::enableOffTimer | ( | const uint16_t | endtime | ) |

Set the enable status & time of the Off Timer.

Parameters

  [in] | endtime | The number of minutes past midnight.

## ◆ enableOnTimer()

void IRDaikinESP::enableOnTimer | ( | const uint16_t | starttime | ) |

Set the enable status & time of the On Timer.

Parameters

  [in] | starttime | The number of minutes past midnight.

## ◆ getComfort()

bool IRDaikinESP::getComfort | ( | void |  | ) | const

Get the Comfort mode of the A/C.

Returns
  true, the setting is on. false, the setting is off.

## ◆ getCurrentDay()

uint8_t IRDaikinESP::getCurrentDay | ( | void |  | ) | const

Get the current day of the week to be sent to the A/C unit.

Returns
  The numerical representation of the day of the week.

Note
  1 is SUN, 2 is MON, ..., 7 is SAT

## ◆ getCurrentTime()

uint16_t IRDaikinESP::getCurrentTime | ( | void |  | ) | const

Get the clock time to be sent to the A/C unit.

Returns
  The number of minutes past midnight.

## ◆ getEcono()

bool IRDaikinESP::getEcono | ( | void |  | ) | const

Get the Economical mode of the A/C.

Returns
  true, the setting is on. false, the setting is off.

## ◆ getFan()

uint8_t IRDaikinESP::getFan | ( | void |  | ) | const

Get the current fan speed setting.

Returns
  The current fan speed.

## ◆ getMode()

uint8_t IRDaikinESP::getMode | ( | void |  | ) | const

Get the operating mode setting of the A/C.

Returns
  The current operating mode setting.

## ◆ getMold()

bool IRDaikinESP::getMold | ( | void |  | ) | const

Get the Mould mode status of the A/C.

Returns
  true, the setting is on. false, the setting is off.

## ◆ getOffTime()

uint16_t IRDaikinESP::getOffTime | ( | void |  | ) | const

Get the Off Timer time to be sent to the A/C unit.

Returns
  The number of minutes past midnight.

## ◆ getOffTimerEnabled()

bool IRDaikinESP::getOffTimerEnabled | ( | void |  | ) | const

Get the enable status of the Off Timer.

Returns
  true, the setting is on. false, the setting is off.

## ◆ getOnTime()

uint16_t IRDaikinESP::getOnTime | ( | void |  | ) | const

Get the On Timer time to be sent to the A/C unit.

Returns
  The number of minutes past midnight.

## ◆ getOnTimerEnabled()

bool IRDaikinESP::getOnTimerEnabled | ( | void |  | ) | const

Get the enable status of the On Timer.

Returns
  true, the setting is on. false, the setting is off.

## ◆ getPower()

bool IRDaikinESP::getPower | ( | void |  | ) | const

Get the value of the current power setting.

Returns
  true, the setting is on. false, the setting is off.

## ◆ getPowerful()

bool IRDaikinESP::getPowerful | ( | void |  | ) | const

Get the Powerful (Turbo) mode of the A/C.

Returns
  true, the setting is on. false, the setting is off.

## ◆ getQuiet()

bool IRDaikinESP::getQuiet | ( | void |  | ) | const

Get the Quiet mode status of the A/C.

Returns
  true, the setting is on. false, the setting is off.

## ◆ getRaw()

uint8_t * IRDaikinESP::getRaw | ( | void |  | ) |

Get a PTR to the internal state/code for this protocol.

Returns
  PTR to a code for this protocol based on the current internal state.

## ◆ getSensor()

bool IRDaikinESP::getSensor | ( | void |  | ) | const

Get the Sensor mode of the A/C.

Returns
  true, the setting is on. false, the setting is off.

## ◆ getSwingHorizontal()

bool IRDaikinESP::getSwingHorizontal | ( | void |  | ) | const

Get the Horizontal Swing mode of the A/C.

Returns
  true, the setting is on. false, the setting is off.

## ◆ getSwingVertical()

bool IRDaikinESP::getSwingVertical | ( | void |  | ) | const

Get the Vertical Swing mode of the A/C.

Returns
  true, the setting is on. false, the setting is off.

## ◆ getTemp()

uint8_t IRDaikinESP::getTemp | ( | void |  | ) | const

Get the current temperature setting.

Returns
  The current setting for temp. in degrees celsius.

## ◆ getWeeklyTimerEnable()

bool IRDaikinESP::getWeeklyTimerEnable | ( | void |  | ) | const

Get the enable status of the Weekly Timer.

Returns
  true, the setting is on. false, the setting is off.

## ◆ off()

void IRDaikinESP::off | ( | void |  | ) |

Change the power setting to Off.

## ◆ on()

void IRDaikinESP::on | ( | void |  | ) |

Change the power setting to On.

## ◆ send()

void IRDaikinESP::send | ( | const uint16_t | repeat = `kDaikinDefaultRepeat` | ) |

Send the current internal state as an IR message.

Parameters

  [in] | repeat | Nr. of times the message will be repeated.

## ◆ setComfort()

void IRDaikinESP::setComfort | ( | const bool | on | ) |

Set the Comfort mode of the A/C.

Parameters

  [in] | on | true, the setting is on. false, the setting is off.

## ◆ setCurrentDay()

void IRDaikinESP::setCurrentDay | ( | const uint8_t | day_of_week | ) |

Set the current day of the week to be sent to the A/C unit.

Parameters

  [in] | day_of_week | The numerical representation of the day of the week.

Note
  1 is SUN, 2 is MON, ..., 7 is SAT

## ◆ setCurrentTime()

void IRDaikinESP::setCurrentTime | ( | const uint16_t | mins_since_midnight | ) |

Set the clock on the A/C unit.

Parameters

  [in] | mins_since_midnight | Nr. of minutes past midnight.

## ◆ setEcono()

void IRDaikinESP::setEcono | ( | const bool | on | ) |

Set the Economy mode of the A/C.

Parameters

  [in] | on | true, the setting is on. false, the setting is off.

## ◆ setFan()

void IRDaikinESP::setFan | ( | const uint8_t | fan | ) |

Set the speed of the fan.

Parameters

  [in] | fan | The desired setting.

Note
  1-5 or kDaikinFanAuto or kDaikinFanQuiet

## ◆ setMode()

void IRDaikinESP::setMode | ( | const uint8_t | mode | ) |

Set the operating mode of the A/C.

Parameters

  [in] | mode | The desired operating mode.

## ◆ setMold()

void IRDaikinESP::setMold | ( | const bool | on | ) |

Set the Mould mode of the A/C.

Parameters

  [in] | on | true, the setting is on. false, the setting is off.

## ◆ setPower()

void IRDaikinESP::setPower | ( | const bool | on | ) |

Change the power setting.

Parameters

  [in] | on | true, the setting is on. false, the setting is off.

## ◆ setPowerful()

void IRDaikinESP::setPowerful | ( | const bool | on | ) |

Set the Powerful (Turbo) mode of the A/C.

Parameters

  [in] | on | true, the setting is on. false, the setting is off.

## ◆ setQuiet()

void IRDaikinESP::setQuiet | ( | const bool | on | ) |

Set the Quiet mode of the A/C.

Parameters

  [in] | on | true, the setting is on. false, the setting is off.

## ◆ setRaw()

void IRDaikinESP::setRaw | ( | const uint8_t | new_code[],
|  | const uint16_t | length = `kDaikinStateLength`
| ) |  |

Set the internal state from a valid code for this protocol.

Parameters

  [in] | new_code | A valid code for this protocol.
  [in] | length | Length of the code in bytes.

## ◆ setSensor()

void IRDaikinESP::setSensor | ( | const bool | on | ) |

Set the Sensor mode of the A/C.

Parameters

  [in] | on | true, the setting is on. false, the setting is off.

## ◆ setSwingHorizontal()

void IRDaikinESP::setSwingHorizontal | ( | const bool | on | ) |

Set the Horizontal Swing mode of the A/C.

Parameters

  [in] | on | true, the setting is on. false, the setting is off.

## ◆ setSwingVertical()

void IRDaikinESP::setSwingVertical | ( | const bool | on | ) |

Set the Vertical Swing mode of the A/C.

Parameters

  [in] | on | true, the setting is on. false, the setting is off.

## ◆ setTemp()

void IRDaikinESP::setTemp | ( | const uint8_t | temp | ) |

Set the temperature.

Parameters

  [in] | temp | The temperature in degrees celsius.

## ◆ setWeeklyTimerEnable()

void IRDaikinESP::setWeeklyTimerEnable | ( | const bool | on | ) |

Set the enable status of the Weekly Timer.

Parameters

  [in] | on | true, the setting is on. false, the setting is off.

## ◆ stateReset()

void IRDaikinESP::stateReset | ( | void |  | ) |

private

Reset the internal state to a fixed known good state.

## ◆ toCommon()

stdAc::state_t IRDaikinESP::toCommon | ( | void |  | ) | const

Convert the current internal state into its stdAc::state_t equivalent.

Returns
  The stdAc equivalent of the native settings.

## ◆ toCommonFanSpeed()

stdAc::fanspeed_t IRDaikinESP::toCommonFanSpeed | ( | const uint8_t | speed | ) |

static

Convert a native fan speed into its stdAc equivalent.

Parameters

  [in] | speed | The native setting to be converted.

Returns
  The stdAc equivalent of the native setting.

## ◆ toCommonMode()

stdAc::opmode_t IRDaikinESP::toCommonMode | ( | const uint8_t | mode | ) |

static

Convert a native mode into its stdAc equivalent.

Parameters

  [in] | mode | The native setting to be converted.

Returns
  The stdAc equivalent of the native setting.

## ◆ toString()

String IRDaikinESP::toString | ( | void |  | ) | const

Convert the current internal state into a human readable string.

Returns
  A human readable string.

## ◆ validChecksum()

bool IRDaikinESP::validChecksum | ( | uint8_t | state[],
|  | const uint16_t | length = `kDaikinStateLength`
| ) |  |

static

Verify the checksum is valid for a given state.

Parameters

  [in] | state | The array to verify the checksum of.
  [in] | length | The length of the state array.

Returns
  true, if the state has a valid checksum. Otherwise, false.

## Member Data Documentation

## ◆ _

DaikinESPProtocol IRDaikinESP::_

private

## ◆ _irsend

IRsend IRDaikinESP::_irsend

private

instance of the IR send class

The documentation for this class was generated from the following files:

- src/ir_Daikin.h
- src/ir_Daikin.cpp